<?php
defined('BASEPATH') OR exit('No direct script access allowed');


class M_Activity extends CI_Model {
		function __construct()
		{
			parent:: __construct();
			$this->yzdb = $this->load->database('YZDB', TRUE);
			$this->db221 = $this->load->database('DB221', TRUE);
		}
		
		public function is_online($user_id){
			$sql = "SELECT A.USER_ID,CASE WHEN A.USER_SIAK IS NULL THEN '-' ELSE A.USER_SIAK END AS USER_SIAK,CASE WHEN TO_CHAR(B.LAST_ACTIVITY,'DD-MM-YYYY HH24:MI:SS') IS NULL THEN '-' ELSE TO_CHAR(B.LAST_ACTIVITY,'DD-MM-YYYY HH24:MI:SS') END AS MONEV_LAST, CASE WHEN B.IP_ADDRESS IS NULL THEN '-' ELSE B.IP_ADDRESS END AS MONEV_IP,CASE WHEN C.LAST_ACTIVITY IS NULL THEN '-' ELSE TO_CHAR(TO_DATE('1970-01-01','YYYY-MM-DD') + NUMTODSINTERVAL(TO_CHAR(C.LAST_ACTIVITY),'SECOND') + 7/24,'DD-MM-YYYY HH24:MI:SS') END AS SIAK_LAST,CASE WHEN C.IP_ADDRESS IS NULL THEN '-' ELSE C.IP_ADDRESS END AS  SIAK_IP FROM SIAK_USER_PLUS A LEFT JOIN SIAK_SESSION_PLUS B ON A.USER_ID = B.USER_ID LEFT JOIN T5_SESSION@DB222 C ON A.USER_SIAK = C.USER_ID WHERE A.USER_ID = '$user_id' ORDER BY C.LAST_ACTIVITY DESC NULLS LAST";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_all_activity($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID, E.NIK, E.NAMA_LGKP, TO_CHAR(A.ACTIVITY_DATE, 'HH24:MI')AS ACTIVITY_DATE, B.ACTIVITY_NAME AS P1,C.ACTIVITY_NAME AS P2, A.ACTIVITY_DESC AS P3 FROM T5_HIST_ACTIVITY@DB222 A INNER JOIN T5_HIST_ACTIVITY_REF@DB222 B ON A.ACTIVITY_TYPE = B.ACTIVITY_ID INNER JOIN T5_HIST_ACTIVITY_REF@DB222 C ON A.ACTIVITY_MOD = C.ACTIVITY_ID INNER JOIN SIAK_USER_PLUS E ON A.USER_ID = E.USER_SIAK WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND ACTIVITY_DATE >= TO_DATE('$nowdate','DD/MM/yyyy') AND ACTIVITY_DATE < TO_DATE('$nowdate','DD/MM/yyyy')+1 ORDER BY A.ACTIVITY_DATE DESC";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_recap_activity($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT COUNT(1) AS JML ,A.USER_ID, CONCAT(B.ACTIVITY_NAME,CONCAT(' ',C.ACTIVITY_NAME)) AS P1 FROM T5_HIST_ACTIVITY@DB222 A INNER JOIN T5_HIST_ACTIVITY_REF@DB222 B ON A.ACTIVITY_TYPE = B.ACTIVITY_ID INNER JOIN T5_HIST_ACTIVITY_REF@DB222 C ON A.ACTIVITY_MOD = C.ACTIVITY_ID WHERE 
				ACTIVITY_DATE >= TO_DATE('$nowdate','DD/MM/yyyy') AND ACTIVITY_DATE < TO_DATE('$nowdate','DD/MM/yyyy')+1 AND A.USER_ID ='$user_id'
				GROUP BY CONCAT(B.ACTIVITY_NAME,CONCAT(' ',C.ACTIVITY_NAME)),A.USER_ID ORDER BY CONCAT(B.ACTIVITY_NAME,CONCAT(' ',C.ACTIVITY_NAME))";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_count_activity($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT COUNT(1) AS JML FROM T5_HIST_ACTIVITY@DB222 A INNER JOIN T5_HIST_ACTIVITY_REF@DB222 B ON A.ACTIVITY_TYPE = B.ACTIVITY_ID INNER JOIN T5_HIST_ACTIVITY_REF@DB222 C ON A.ACTIVITY_MOD = C.ACTIVITY_ID INNER JOIN SIAK_USER_PLUS E ON A.USER_ID = E.USER_SIAK WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND ACTIVITY_DATE >= TO_DATE('$nowdate','DD/MM/yyyy') AND ACTIVITY_DATE < TO_DATE('$nowdate','DD/MM/yyyy')+1 ORDER BY A.ACTIVITY_DATE DESC";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r[0]->JML;
		}
		public function get_all_bcard($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT CASE WHEN A.LAST_UPDATED_USERNAME IS NULL THEN A.CREATED_USERNAME ELSE A.LAST_UPDATED_USERNAME END AS USER_ID, E.NIK, E.NAMA_LGKP, TO_CHAR(A.PERSONALIZED_DATE, 'HH24:MI')AS ACTIVITY_DATE, 'PENCETAKAN' AS P1,'E-KTP' AS P2, CONCAT(CONCAT(CONCAT('NIK : ',A.NIK),'<br />'),(SELECT CONCAT(CONCAT(CONCAT('NIK : ',X.NAMA_LGKP),'<br />'),CONCAT('E-KTP STATUS CODE : ',X.CURRENT_STATUS_CODE)) FROM DEMOGRAPHICS@DB2 X WHERE A.NIK = X.NIK)) AS P3 FROM CARD_MANAGEMENT@DB2 A INNER JOIN  SIAK_USER_PLUS E ON CASE WHEN UPPER(A.LAST_UPDATED_USERNAME) IS NULL THEN UPPER(A.CREATED_USERNAME) ELSE UPPER(A.LAST_UPDATED_USERNAME) END = UPPER(E.USER_BCARD)    WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND CASE WHEN TO_CHAR(LAST_UPDATE,'DD/MM/YYYY') IS NULL THEN TO_CHAR(PERSONALIZED_DATE,'DD/MM/YYYY') ELSE TO_CHAR(LAST_UPDATE,'DD/MM/YYYY') END =  '$nowdate'  ORDER BY A.PERSONALIZED_DATE DESC";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_count_bcard($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT COUNT(1) AS JML FROM CARD_MANAGEMENT@DB2 A INNER JOIN  SIAK_USER_PLUS E ON CASE WHEN UPPER(A.LAST_UPDATED_USERNAME) IS NULL THEN UPPER(A.CREATED_USERNAME) ELSE UPPER(A.LAST_UPDATED_USERNAME) END = UPPER(E.USER_BCARD)    WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND CASE WHEN TO_CHAR(LAST_UPDATE,'DD/MM/YYYY') IS NULL THEN TO_CHAR(PERSONALIZED_DATE,'DD/MM/YYYY') ELSE TO_CHAR(LAST_UPDATE,'DD/MM/YYYY') END =  '$nowdate' ORDER BY A.PERSONALIZED_DATE DESC";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r[0]->JML;
		}
		public function get_all($user_id){
			
			$sql = "SELECT 
					(SELECT COUNT(1) AS JML FROM T5_HIST_ACTIVITY@DB222 A INNER JOIN T5_HIST_ACTIVITY_REF@DB222 B ON A.ACTIVITY_TYPE = B.ACTIVITY_ID INNER JOIN T5_HIST_ACTIVITY_REF@DB222 C ON A.ACTIVITY_MOD = C.ACTIVITY_ID INNER JOIN SIAK_USER_PLUS E ON A.USER_ID = E.USER_SIAK WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND TO_CHAR(ACTIVITY_DATE,'MM/YYYY') = TO_CHAR(SYSDATE,'MM/YYYY')) ALL_SIAK,
					(SELECT COUNT(1) AS JML FROM DEMOGRAPHICS@DB221 A INNER JOIN  SIAK_USER_PLUS E ON A.CREATED_USERNAME = E.USER_BENROL WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND TO_CHAR(CREATED,'MM/YYYY') = TO_CHAR(SYSDATE,'MM/YYYY')) ALL_REKAM,
					(SELECT COUNT(1) AS JML FROM CARD_MANAGEMENT@DB2 A INNER JOIN  SIAK_USER_PLUS E ON CASE WHEN UPPER(A.LAST_UPDATED_USERNAME) IS NULL THEN UPPER(A.CREATED_USERNAME) ELSE UPPER(A.LAST_UPDATED_USERNAME) END = UPPER(E.USER_BCARD)    WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND CASE WHEN TO_CHAR(LAST_UPDATE,'MM/YYYY') IS NULL THEN TO_CHAR(PERSONALIZED_DATE,'MM/YYYY') ELSE TO_CHAR(LAST_UPDATE,'MM/YYYY') END =  TO_CHAR(SYSDATE,'MM/YYYY')) ALL_CETAK 
					FROM DUAL";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_all_benroll($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.CREATED_USERNAME AS USER_ID, E.NIK, E.NAMA_LGKP, TO_CHAR(A.CREATED, 'HH24:MI')AS ACTIVITY_DATE, 'PEREKAMAN' AS P1,'E-KTP' AS P2, CONCAT(CONCAT(CONCAT('NIK : ',A.NIK),'<br />'),CONCAT(CONCAT(CONCAT('NAMA : ',A.NAMA_LGKP),'<br />'),CONCAT('E-KTP STATUS CODE : ',A.CURRENT_STATUS_CODE))) AS P3 FROM DEMOGRAPHICS@DB221 A INNER JOIN  SIAK_USER_PLUS E ON A.CREATED_USERNAME = E.USER_BENROL WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND TO_CHAR(CREATED,'DD/MM/YYYY') = '$nowdate' ORDER BY A.CREATED DESC";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_count_benroll($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT COUNT(1) AS JML FROM DEMOGRAPHICS@DB221 A INNER JOIN  SIAK_USER_PLUS E ON A.CREATED_USERNAME = E.USER_BENROL WHERE (E.USER_LEVEL =1 OR E.USER_LEVEL =3) AND E.USER_ID = '$user_id' AND TO_CHAR(CREATED,'DD/MM/YYYY') = '$nowdate' ORDER BY A.CREATED DESC";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r[0]->JML;
		}
		public function get_clockin($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID, CASE WHEN JAM_MASUK IS NULL THEN '-' ELSE JAM_MASUK END  AS JML FROM SIAK_USER_PLUS A LEFT JOIN  SIAK_ABSENSI B ON A.USER_ID = B.USER_ID AND TO_CHAR(B.TANGGAL,'DD/MM/YYYY') = '$nowdate' WHERE A.USER_ID = '$user_id'";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r[0]->JML;
		}
		public function get_clockout($user_id){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID, CASE WHEN JAM_KELUAR IS NULL THEN '-' ELSE JAM_KELUAR END  AS JML FROM SIAK_USER_PLUS A LEFT JOIN  SIAK_ABSENSI B ON A.USER_ID = B.USER_ID AND TO_CHAR(B.TANGGAL,'DD/MM/YYYY') = '$nowdate' WHERE A.USER_ID = '$user_id'";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r[0]->JML;
		}
		public function get_master_activity(){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID,A.NAMA_LGKP, A.NAMA_KANTOR, A.NIK
                    , CASE WHEN B.PEREKAMAN IS NULL THEN 0 ELSE B.PEREKAMAN END AS PEREKAMAN  
                    , CASE WHEN C.PENCETAKAN IS NULL THEN 0 ELSE C.PENCETAKAN END AS PENCETAKAN  
                    , CASE WHEN D.SIAK IS NULL THEN 0 ELSE D.SIAK END AS SIAK
                    FROM SIAK_USER_PLUS@YZDB A 
                    LEFT JOIN (SELECT e.user_id, COUNT(1) AS PEREKAMAN FROM DEMOGRAPHICS@DB221 A INNER JOIN  SIAK_USER_PLUS@YZDB E ON A.CREATED_USERNAME = E.USER_BENROL WHERE E.USER_LEVEL =1 AND TO_CHAR(CREATED,'DD/MM/YYYY') = '$nowdate' group by e.user_id) B 
                    ON A.USER_ID = B.USER_ID
                    LEFT JOIN (SELECT E.USER_ID, COUNT(1) AS PENCETAKAN FROM CARD_MANAGEMENT@DB2 A INNER JOIN  SIAK_USER_PLUS@YZDB E ON CASE WHEN UPPER(A.LAST_UPDATED_USERNAME) IS NULL THEN UPPER(A.CREATED_USERNAME) ELSE UPPER(A.LAST_UPDATED_USERNAME) END = UPPER(E.USER_BCARD)    WHERE E.USER_LEVEL =1  AND CASE WHEN TO_CHAR(A.LAST_UPDATE,'DD/MM/YYYY') IS NULL THEN TO_CHAR(A.PERSONALIZED_DATE,'DD/MM/YYYY') ELSE TO_CHAR(A.LAST_UPDATE,'DD/MM/YYYY') END =  '$nowdate' GROUP BY E.USER_ID) C
                    ON A.USER_ID = C.USER_ID
                    LEFT JOIN (SELECT E.USER_ID, COUNT(1) AS SIAK FROM T5_HIST_ACTIVITY A INNER JOIN T5_HIST_ACTIVITY_REF B ON A.ACTIVITY_TYPE = B.ACTIVITY_ID INNER JOIN T5_HIST_ACTIVITY_REF C ON A.ACTIVITY_MOD = C.ACTIVITY_ID INNER JOIN SIAK_USER_PLUS@YZDB E ON A.USER_ID = E.USER_SIAK WHERE E.USER_LEVEL =1 AND ACTIVITY_DATE >= TO_DATE('$nowdate','DD/MM/yyyy') AND ACTIVITY_DATE < TO_DATE('$nowdate','DD/MM/yyyy')+1 GROUP BY E.USER_ID) D
                    ON A.USER_ID = D.USER_ID
                    WHERE A.USER_LEVEL = 1 AND A.IS_ASN = 0 ORDER BY TO_NUMBER(A.NO_KEC)";
			$q = $this->db->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_master_activity_dinas(){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID,A.NAMA_LGKP, A.NAMA_KANTOR, A.NIK
					, CASE WHEN B.PEREKAMAN IS NULL THEN 0 ELSE B.PEREKAMAN END AS PEREKAMAN  
					, CASE WHEN C.PENCETAKAN IS NULL THEN 0 ELSE C.PENCETAKAN END AS PENCETAKAN  
					, CASE WHEN D.SIAK IS NULL THEN 0 ELSE D.SIAK END AS SIAK
					FROM SIAK_USER_PLUS@YZDB A 
					LEFT JOIN (SELECT e.user_id, COUNT(1) AS PEREKAMAN FROM DEMOGRAPHICS@DB221 A INNER JOIN  SIAK_USER_PLUS@YZDB E ON A.CREATED_USERNAME = E.USER_BENROL WHERE E.USER_LEVEL = 3 AND E.IS_MONITORING = 1 AND A.CREATED >= TO_DATE('$nowdate','DD/MM/yyyy') AND A.CREATED < TO_DATE('$nowdate','DD/MM/yyyy')+1 group by e.user_id) B 
					ON A.USER_ID = B.USER_ID
					LEFT JOIN (SELECT E.USER_ID, COUNT(1) AS PENCETAKAN FROM CARD_MANAGEMENT@DB2 A INNER JOIN  SIAK_USER_PLUS@YZDB E ON CASE WHEN UPPER(A.LAST_UPDATED_USERNAME) IS NULL THEN UPPER(A.CREATED_USERNAME) ELSE UPPER(A.LAST_UPDATED_USERNAME) END = UPPER(E.USER_BCARD)    WHERE E.USER_LEVEL = 3 AND E.IS_MONITORING = 1  AND CASE WHEN TO_CHAR(A.LAST_UPDATE,'DD/MM/YYYY') IS NULL THEN TO_CHAR(A.PERSONALIZED_DATE,'DD/MM/YYYY') ELSE TO_CHAR(A.LAST_UPDATE,'DD/MM/YYYY') END =  TO_CHAR(SYSDATE,'DD/MM/YYYY') GROUP BY E.USER_ID) C
					ON A.USER_ID = C.USER_ID
					LEFT JOIN (SELECT E.USER_ID, COUNT(1) AS SIAK FROM T5_HIST_ACTIVITY A INNER JOIN T5_HIST_ACTIVITY_REF B ON A.ACTIVITY_TYPE = B.ACTIVITY_ID INNER JOIN T5_HIST_ACTIVITY_REF C ON A.ACTIVITY_MOD = C.ACTIVITY_ID INNER JOIN SIAK_USER_PLUS@YZDB E ON A.USER_ID = E.USER_SIAK WHERE E.USER_LEVEL = 3 AND E.IS_MONITORING = 1 AND A.ACTIVITY_DATE >= TO_DATE('$nowdate','DD/MM/yyyy') AND A.ACTIVITY_DATE < TO_DATE('$nowdate','DD/MM/yyyy')+1 GROUP BY E.USER_ID) D
					ON A.USER_ID = D.USER_ID
					WHERE A.USER_LEVEL = 3 AND A.IS_MONITORING = 1 ORDER BY TO_NUMBER(A.NO_KEC)";
			$q = $this->db->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_master_absensi(){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID,A.NAMA_LGKP, A.NAMA_KANTOR, A.NIK
                    , CASE WHEN E.JAM_MASUK IS NULL THEN '-' ELSE E.JAM_MASUK END AS JAM_MASUK
          			, CASE WHEN E.JAM_KELUAR IS NULL THEN '-' ELSE E.JAM_KELUAR END AS JAM_KELUAR
                    FROM SIAK_USER_PLUS A 
                    LEFT JOIN SIAK_ABSENSI E ON A.USER_ID = E.USER_ID AND TO_CHAR(E.TANGGAL,'DD/MM/YYYY') = TO_CHAR(SYSDATE,'DD/MM/YYYY')
                    WHERE  A.IS_ASN = 0 AND A.USER_ID NOT IN ('cidadap','bawet','cinambo','REGOL1') ORDER BY USER_LEVEL, TO_NUMBER(A.NO_KEC), A.NAMA_LGKP";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_master_absensi_dinas(){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID,A.NAMA_LGKP, A.NAMA_KANTOR, A.NIK
          			, CASE WHEN E.JAM_MASUK IS NULL THEN '-' ELSE E.JAM_MASUK END AS JAM_MASUK
          			, CASE WHEN E.JAM_KELUAR IS NULL THEN '-' ELSE E.JAM_KELUAR END AS JAM_KELUAR
					FROM SIAK_USER_PLUS A 
          			LEFT JOIN SIAK_ABSENSI E ON A.USER_ID = E.USER_ID AND TO_CHAR(E.TANGGAL,'DD/MM/YYYY') = TO_CHAR(SYSDATE,'DD/MM/YYYY')
					WHERE A.USER_LEVEL = 3 AND A.IS_MONITORING = 1 ORDER BY TO_NUMBER(A.NO_KEC)";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function get_master_pengajuan(){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID,A.NAMA_LGKP, A.NAMA_KANTOR, A.NIK
                   , CASE WHEN TO_CHAR(F.PENGAJUAN_B) = '0'  THEN '-' ELSE TO_CHAR(F.PENGAJUAN_B) END AS PENGAJUAN_B
                    , CASE WHEN TO_CHAR(F.PENGAJUAN_N) = '0'  THEN '-' ELSE TO_CHAR(F.PENGAJUAN_N) END AS PENGAJUAN_N
                    , CASE WHEN TO_CHAR(F.PENGAJUAN_Y) = '0' THEN '-' ELSE TO_CHAR(F.PENGAJUAN_Y) END AS PENGAJUAN_Y
                    FROM SIAK_USER_PLUS A 
                    LEFT JOIN (SELECT A.NO_KEC, SUM(CASE WHEN TO_CHAR(REQ_DATE,'MM/YYYY')= TO_CHAR(SYSDATE,'MM/YYYY') THEN 1 ELSE 0 END) PENGAJUAN_B,SUM(CASE WHEN TO_CHAR(REQ_DATE,'DD/MM/YYYY')= TO_CHAR(SYSDATE,'DD/MM/YYYY') THEN 1 ELSE 0 END) PENGAJUAN_N,SUM(CASE WHEN TO_CHAR(REQ_DATE,'DD/MM/YYYY')= TO_CHAR(SYSDATE-1,'DD/MM/YYYY') THEN 1 ELSE 0 END) PENGAJUAN_Y  FROM BIODATA_WNI@DB222 A INNER JOIN T5_REQ_CETAK_KTP@DB222 B ON A.NIK = B.NIK GROUP BY A.NO_KEC ORDER BY A.NO_KEC) F ON A.NO_KEC =F.NO_KEC
                    WHERE A.USER_LEVEL = 1 AND A.IS_ASN = 0 ORDER BY TO_NUMBER(A.NO_KEC)";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		/*public function get_master_list(){
			$nowdate = date("d/m/Y");
			$sql = "SELECT A.USER_ID,A.NAMA_LGKP, A.NAMA_KANTOR, A.NIK
                   , CASE WHEN TO_CHAR(G.JML) = '0' OR TO_CHAR(G.JML) IS NULL THEN '-' ELSE TO_CHAR(G.JML) END AS PENGAJUAN_S
                    , CASE WHEN TO_CHAR(H.JML) = '0' OR TO_CHAR(H.JML) IS NULL THEN '-' ELSE TO_CHAR(H.JML) END AS PRR_S
                    , CASE WHEN TO_CHAR(F.JML) = '0' OR TO_CHAR(F.JML) IS NULL THEN '-' ELSE TO_CHAR(F.JML) END AS SUKET_S
                    FROM SIAK_USER_PLUS@YZDB A 
                   LEFT JOIN (SELECT COUNT(1) AS JML, A.NO_KEC FROM (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (TO_DATE(A.REQ_DATE,'DD-MM-YYYY') > TO_DATE(C.PERSONALIZED_DATE,'DD-MM-YYYY') OR C.PERSONALIZED_DATE IS NULL) AND EXISTS(SELECT 1 FROM BIODATA_WNI X WHERE A.NIK = X.NIK) GROUP BY A.NO_KEC) G ON A.NO_KEC = G.NO_KEC
                    LEFT JOIN (SELECT 
                    COUNT(1) AS JML, B.NO_KEC
                    FROM DEMOGRAPHICS@DB221 A 
                    INNER JOIN BIODATA_WNI B ON A.NIK = B.NIK
                    LEFT JOIN DATA_KELUARGA C ON B.NO_KK = C.NO_KK
                    WHERE A.CURRENT_STATUS_CODE = 'PRINT_READY_RECORD' 
                    AND (B.TGL_LHR<=ADD_MONTHS(SYSDATE,-12*17) OR B.STAT_KWN<>1) 
                    AND (B.FLAG_STATUS = '0' OR (B.FLAG_STATUS = '2' AND B.FLAG_PINDAH IN(1,2,3))) 
                    AND B.NO_PROP = 32 AND B.NO_KAB =73  
                    AND NOT EXISTS(SELECT 1 FROM CARD_MANAGEMENT@DB2 D WHERE A.NIK = D.NIK)
                    AND NOT EXISTS(SELECT 1 FROM DEMOGRAPHICS@DB2 D WHERE A.NIK = D.NIK AND D.CURRENT_STATUS_CODE LIKE '%CARD%')
                    GROUP BY B.NO_KEC) H ON A.NO_KEC = H.NO_KEC
                    LEFT JOIN (SELECT 
                  A.NO_KEC
             	  ,COUNT(1) JML
                  FROM BIODATA_WNI A 
                  INNER JOIN (SELECT NIK, PRINTED_DATE,PRINTED_BY,NO_DOKUMEN  FROM (SELECT NIK,PRINTED_DATE,PRINTED_BY,NO_DOKUMEN, RANK() OVER (PARTITION BY NIK ORDER BY PRINTED_DATE,NO_DOKUMEN DESC) RNK FROM T7_HIST_SUKET WHERE TIPE = 1)
                  WHERE RNK = 1) B ON A.NIK = B.NIK
                  LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME,LAST_UPDATE FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME,LAST_UPDATE, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) 
                  WHERE RNK = 1) C ON A.NIK =C.NIK
                  LEFT JOIN DEMOGRAPHICS_ALL@DB2 D ON A.NIK = D.NIK WHERE C.NIK IS NULL AND (D.CURRENT_STATUS_CODE LIKE '%CARD%' OR D.CURRENT_STATUS_CODE = 'PRINT_READY_RECORD') AND  (A.TGL_LHR<=ADD_MONTHS(SYSDATE,-12*17) OR A.STAT_KWN<>1) 
                    AND (A.FLAG_STATUS = '0' OR (A.FLAG_STATUS = '2' AND A.FLAG_PINDAH IN(1,2,3))) 
                    AND A.NO_PROP = 32 AND A.NO_KAB =73   GROUP BY A.NO_KEC ORDER BY A.NO_KEC) F ON A.NO_KEC = F.NO_KEC
                    WHERE A.USER_LEVEL = 1 AND A.IS_ASN = 0 ORDER BY TO_NUMBER(A.NO_KEC)";
			$q = $this->db->query($sql);
			$r = $q->result();
			return $r;
		}*/
		public function get_master_list(){
			$nowdate = date("d/m/Y");
			$sql = "SELECT USER_ID, NAMA_LGKP, NAMA_KANTOR, NIK, PENGAJUAN_S, PRR_S FROM VW_SIAK_MASTER_LIST";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function cek_daily_activity($tgl_start,$tgl_end,$user_id){
			$sql = "SELECT USER_ID,(SELECT SIAK_USER_PLUS.NAMA_LGKP FROM SIAK_USER_PLUS WHERE SIAK_DAILY.USER_ID = SIAK_USER_PLUS.USER_ID ) AS NAMA, CASE WHEN (SELECT SIAK_ACTIVITY.ACTIVITY FROM SIAK_ACTIVITY WHERE SIAK_ACTIVITY.ACTIVITY_ID = SIAK_DAILY.ACTIVITY_ID) IS NULL THEN 'LAINNYA' ELSE (SELECT SIAK_ACTIVITY.ACTIVITY FROM SIAK_ACTIVITY WHERE SIAK_ACTIVITY.ACTIVITY_ID = SIAK_DAILY.ACTIVITY_ID) END AS AKTIVITAS,UPPER(DESCRIPTION) KETERANGAN,  TO_CHAR(CREATED_DT,'DD-MM-YYYY') AS TGL_AKTIVITAS,START_ACTIVITY AS DARI,END_ACTIVITY AS SAMPAI,NUMBER_ACTIVITY AS JUMLAH_AKTIVITAS FROM SIAK_DAILY WHERE USER_ID = '$user_id' AND CREATED_DT >= TO_DATE('$tgl_start','DD-MM-YYYY') AND CREATED_DT < TO_DATE('$tgl_end','DD-MM-YYYY') +1 ORDER BY USER_ID,CREATED_DT DESC";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function cek_count_daily_activity($tgl_start,$tgl_end,$user_id){
			$sql = "SELECT COUNT(1) AS JML FROM SIAK_DAILY WHERE USER_ID = '$user_id' AND CREATED_DT >= TO_DATE('$tgl_start','DD-MM-YYYY') AND CREATED_DT < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->yzdb->query($sql);
			return $q->row(0)->JML;
		}
		public function cek_daily_absensi($user_id){
			$sql = "SELECT A.USER_ID, A.NAMA_LGKP,TO_CHAR(B.TANGGAL,'DD-MM-YYYY') AS TANGGAL, B.HARI, B.JAM_MASUK, B.JAM_KELUAR,CONCAT(TRUNC(24*(to_date(CONCAT(TO_CHAR(B.TANGGAL,'DD-MM-YYYY'),CONCAT(' ',B.JAM_KELUAR)), 'DD-MM-YYYY hh24:mi') - to_date(CONCAT(TO_CHAR(B.TANGGAL,'DD-MM-YYYY'),CONCAT(' ',B.JAM_MASUK)), 'DD-MM-YYYY hh24:mi')),0),' Jam') AS JAM_KERJA FROM SIAK_USER_PLUS A INNER JOIN
					(SELECT 
					  A.TANGGAL
					  , CASE 
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'SAT' THEN 'SABTU'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'SUN' THEN 'MINGGU'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'MON' THEN 'SENIN'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'TUE' THEN 'SELASA'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'WED' THEN 'RABU'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'THU' THEN 'KAMIS'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'FRI' THEN 'JUMAT'
					  ELSE '' END AS HARI
					  , '$user_id' AS USER_ID
					  , CASE WHEN JAM_MASUK IS NULL THEN '-' ELSE JAM_MASUK END AS JAM_MASUK
					  , CASE WHEN JAM_KELUAR IS NULL THEN '-' ELSE JAM_KELUAR END AS JAM_KELUAR
					   FROM (SELECT TRUNC(SYSDATE, 'YYYY') + LEVEL - 1 AS TANGGAL	FROM DUAL CONNECT BY TRUNC(TRUNC(SYSDATE, 'YYYY') + LEVEL - 1, 'YYYY') = TRUNC(SYSDATE, 'YYYY')) A LEFT JOIN (select USER_ID,TANGGAL, NAMA, JAM_MASUK, JAM_KELUAR, KETERANGAN FROM SIAK_ABSENSI WHERE USER_ID ='$user_id') B ON A.TANGGAL = B.TANGGAL WHERE A.TANGGAL >= TO_DATE('02-02-2018','DD-MM-YYYY') AND A.TANGGAL <= TO_DATE('30-11-2018','DD-MM-YYYY')+1 ) B ON A.USER_ID = B.USER_ID  ORDER BY B.TANGGAL";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		public function cek_count_daily_absensi($user_id){
			$sql = "SELECT COUNT(1) AS JML FROM SIAK_USER_PLUS A INNER JOIN
					(SELECT 
					  A.TANGGAL
					  , CASE 
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'SAT' THEN 'SABTU'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'SUN' THEN 'MINGGU'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'MON' THEN 'SENIN'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'TUE' THEN 'SELASA'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'WED' THEN 'RABU'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'THU' THEN 'KAMIS'
					  WHEN TO_CHAR (A.TANGGAL, 'DY') = 'FRI' THEN 'JUMAT'
					  ELSE '' END AS HARI
					  , '$user_id' AS USER_ID
					  , CASE WHEN JAM_MASUK IS NULL THEN '-' ELSE JAM_MASUK END AS JAM_MASUK
					  , CASE WHEN JAM_KELUAR IS NULL THEN '-' ELSE JAM_KELUAR END AS JAM_KELUAR
					   FROM (SELECT TRUNC(SYSDATE, 'YYYY') + LEVEL - 1 AS TANGGAL	FROM DUAL CONNECT BY TRUNC(TRUNC(SYSDATE, 'YYYY') + LEVEL - 1, 'YYYY') = TRUNC(SYSDATE, 'YYYY')) A LEFT JOIN (select USER_ID,TANGGAL, NAMA, JAM_MASUK, JAM_KELUAR, KETERANGAN FROM SIAK_ABSENSI WHERE USER_ID ='$user_id') B ON A.TANGGAL = B.TANGGAL WHERE A.TANGGAL >= TO_DATE('02-02-2018','DD-MM-YYYY') AND A.TANGGAL <= TO_DATE('30-11-2018','DD-MM-YYYY')+1 ) B ON A.USER_ID = B.USER_ID  ORDER BY B.TANGGAL";
			$q = $this->yzdb->query($sql);
			return $q->row(0)->JML;
		}
		public function get_user($user_id){
			$sql = "SELECT USER_ID,USER_PWD, NAMA_LGKP, NIK, TMPT_LHR, TO_CHAR(TGL_LHR,'DD-MM-YYYY') TGL_LHR, CASE WHEN JENIS_KLMIN =1 THEN 'LAKI-LAKI' ELSE 'PEREMPUAN' END JENIS_KLMIN, CASE WHEN TELP IS NULL THEN '-' ELSE TELP END TELP, CASE WHEN USER_SIAK IS NULL THEN '-' ELSE USER_SIAK END USER_SIAK, CASE WHEN USER_BCARD IS NULL THEN '-' ELSE USER_BCARD END USER_BCARD, CASE WHEN USER_BENROL IS NULL THEN '-' ELSE USER_BENROL END USER_BENROL  FROM SIAK_USER_PLUS WHERE USER_ID = '$user_id'";
			$q = $this->yzdb->query($sql);
			$r = $q->result();
			return $r;
		}
		function get_no_prop()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_no_prop();
    	}
    	function get_no_kab()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_no_kab();
    	}
    	function get_siak_dblink()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_siak_dblink();
    	}
    	function get_rekam_dblink()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_rekam_dblink();
    	}
    	function get_cetak_dblink()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_cetak_dblink();
    	}
    	function get_master_dblink()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_master_dblink();
    	}
}